diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/buildings/test/buildings-penetration-loss-pathloss-test.cc ns-3.47/src/buildings/test/buildings-penetration-loss-pathloss-test.cc
--- ns-3.46/src/buildings/test/buildings-penetration-loss-pathloss-test.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/buildings/test/buildings-penetration-loss-pathloss-test.cc	2026-02-16 16:08:49.576229800 -0800
@@ -16,29 +16,44 @@
 #include "ns3/log.h"
 #include "ns3/mobility-building-info.h"
 #include "ns3/mobility-helper.h"
+#include "ns3/rng-seed-manager.h"
 #include "ns3/simulator.h"
 #include "ns3/test.h"
 #include "ns3/three-gpp-propagation-loss-model.h"
 
+#include <numeric>
+
 using namespace ns3;
 
 NS_LOG_COMPONENT_DEFINE("BuildingsPenetrationLossesTest");
 
+using O2ILH = ChannelCondition::O2iLowHighConditionValue;
+
 /**
  * @ingroup propagation-tests
  *
- * Test case for the 3GPP channel O2I building penetration losses.
+ * Test case for the 3GPP channel building and vehicular O2I penetration losses.
  * It considers pre-determined scenarios and based on the outdoor/indoor
  * condition (O2O/O2I) checks whether the calculated received power
  * is aligned with the calculation in 3GPP TR 38.901.
  *
  * For O2O condition the calculation is done according to Table 7.4.1-1
  * and we check if the calculated received power is equal to the expected
- * value.
- * For the O2I condition, the calculation is done considering the building
- * penetration losses based on the material of the building walls.
- * In this case, we check if the calculated received power is less than the
- * received value (thus ensure that losses have been included).
+ * value. O2O condition is also tested when unblocked (LOS),
+ * or blocked (NLOS) by a building.
+
+ * For the O2I condition with frequencies equal or above 6GHz,
+ * the calculation is done considering the building penetration losses
+ * based on the material of the building walls, as specified
+ * in Table 7.4.3-1 and Table 7.4.3-2.
+ * For the O2I condition with frequencies below 6GHz, the calculation
+ * is done considering the backward compatibility model in Table 7.4.3-3.
+ * In both cases, we check if the calculated received power is within
+ * the expected normal distribution.
+ *
+ * All cases are tested with one node at 0 or 30 km/h, representing pedestrian or vehicles.
+ * In case a vehicle is part of a channel link, its O2I losses are applied to the channel,
+ * following procedure in 3GPP TR 38901 Section 7.4.3.2.
  */
 
 class BuildingsPenetrationLossesTestCase : public TestCase
@@ -65,24 +80,23 @@
      */
     struct TestVector
     {
-        Vector m_positionA; //!< the position of the first node
-        Vector m_positionB; //!< the position of the second node
-        double m_frequency; //!< carrier frequency in Hz
-        TypeId m_condModel; //!< the type ID of the channel condition model to be used
-        TypeId m_propModel; //!< the type ID of the propagation loss model to be used
-        double m_pt;        //!< transmitted power in dBm
-        double m_pr;        //!< received power in dBm
+        Vector m_positionA;      //!< the position of the first node
+        Vector m_positionB;      //!< the position of the second node
+        double m_ueVelocity;     //!< velocity in km/h
+        double m_frequency;      //!< carrier frequency in Hz
+        TypeId m_propModel;      //!< the type ID of the propagation loss model to be used
+        O2ILH m_o2iLossType;     //!< type of O2I loss (low/high)
+        double m_expectedMean;   //!< expected mean in dBm
+        double m_expectedStddev; //!< expected deviation in dBm
     };
 
-    TestVectors<TestVector> m_testVectors;         //!< array containing all the test vectors
+    std::vector<TestVector> m_testVectors;         //!< array containing all the test vectors
     Ptr<ThreeGppPropagationLossModel> m_propModel; //!< the propagation loss model
-    double m_tolerance;                            //!< tolerance
 };
 
 BuildingsPenetrationLossesTestCase::BuildingsPenetrationLossesTestCase()
     : TestCase("Test case for BuildingsPenetrationLosses"),
-      m_testVectors(),
-      m_tolerance(2e-3)
+      m_testVectors()
 {
 }
 
@@ -93,158 +107,181 @@
 void
 BuildingsPenetrationLossesTestCase::DoRun()
 {
+    const auto UMi = ThreeGppUmiStreetCanyonPropagationLossModel::GetTypeId();
+    const auto UMa = ThreeGppUmaPropagationLossModel::GetTypeId();
+    const auto RMa = ThreeGppRmaPropagationLossModel::GetTypeId();
     // create the test vector
-    TestVector testVector;
-
-    // tests for the RMa scenario
-    testVector.m_positionA = Vector(0, 0, 35.0); // O2I case
-    testVector.m_positionB = Vector(10, 0, 1.5);
-    testVector.m_frequency = 5.0e9;
-    testVector.m_propModel = ThreeGppRmaPropagationLossModel::GetTypeId();
-    testVector.m_pt = 0.0;
-    testVector.m_pr = -77.3784;
-    m_testVectors.Add(testVector);
-
-    testVector.m_positionA = Vector(0, 0, 35.0); // O2I case
-    testVector.m_positionB = Vector(100, 0, 1.5);
-    testVector.m_frequency = 5.0e9;
-    testVector.m_propModel = ThreeGppRmaPropagationLossModel::GetTypeId();
-    testVector.m_pt = 0.0;
-    testVector.m_pr = -87.2965;
-    m_testVectors.Add(testVector);
-
-    testVector.m_positionA = Vector(0, 0, 35.0); // O2O case
-    testVector.m_positionB = Vector(1000, 0, 1.5);
-    testVector.m_frequency = 5.0e9;
-    testVector.m_propModel = ThreeGppRmaPropagationLossModel::GetTypeId();
-    testVector.m_pt = 0.0;
-    testVector.m_pr = -108.5577;
-    m_testVectors.Add(testVector);
-
-    // tests for the UMa scenario
-    testVector.m_positionA = Vector(0, 0, 25.0); // O2I case
-    testVector.m_positionB = Vector(10, 0, 1.5);
-    testVector.m_frequency = 5.0e9;
-    testVector.m_propModel = ThreeGppUmaPropagationLossModel::GetTypeId();
-    testVector.m_pt = 0.0;
-    testVector.m_pr = -72.9380;
-    m_testVectors.Add(testVector);
-
-    testVector.m_positionA = Vector(0, 0, 25.0); // O2I case
-    testVector.m_positionB = Vector(100, 0, 1.5);
-    testVector.m_frequency = 5.0e9;
-    testVector.m_propModel = ThreeGppUmaPropagationLossModel::GetTypeId();
-    testVector.m_pt = 0.0;
-    testVector.m_pr = -86.2362;
-    m_testVectors.Add(testVector);
-
-    testVector.m_positionA = Vector(0, 0, 25.0); // O2O case
-    testVector.m_positionB = Vector(1000, 0, 1.5);
-    testVector.m_frequency = 5.0e9;
-    testVector.m_propModel = ThreeGppUmaPropagationLossModel::GetTypeId();
-    testVector.m_pt = 0.0;
-    testVector.m_pr = -109.7252;
-    m_testVectors.Add(testVector);
-
-    // tests for the UMi scenario
-    testVector.m_positionA = Vector(0, 0, 10.0); // O2I case
-    testVector.m_positionB = Vector(10, 0, 1.5);
-    testVector.m_frequency = 5.0e9;
-    testVector.m_propModel = ThreeGppUmiStreetCanyonPropagationLossModel::GetTypeId();
-    testVector.m_pt = 0.0;
-    testVector.m_pr = -69.8591;
-    m_testVectors.Add(testVector);
-
-    testVector.m_positionA = Vector(0, 0, 10.0); // O2I case
-    testVector.m_positionB = Vector(100, 0, 1.5);
-    testVector.m_frequency = 5.0e9;
-    testVector.m_propModel = ThreeGppUmiStreetCanyonPropagationLossModel::GetTypeId();
-    testVector.m_pt = 0.0;
-    testVector.m_pr = -88.4122;
-    m_testVectors.Add(testVector);
-
-    testVector.m_positionA = Vector(0, 0, 10.0); // O2O case
-    testVector.m_positionB = Vector(1000, 0, 1.5);
-    testVector.m_frequency = 5.0e9;
-    testVector.m_propModel = ThreeGppUmiStreetCanyonPropagationLossModel::GetTypeId();
-    testVector.m_pt = 0.0;
-    testVector.m_pr = -119.3114;
-    m_testVectors.Add(testVector);
-
-    // create the factory for the propagation loss model
-    ObjectFactory propModelFactory;
-
-    auto building = CreateObject<Building>();
-    building->SetExtWallsType(Building::ExtWallsType_t::ConcreteWithWindows);
-    building->SetNRoomsX(1);
-    building->SetNRoomsY(1);
-    building->SetNFloors(2);
-    building->SetBoundaries(Box(0.0, 100.0, 0.0, 10.0, 0.0, 5.0));
-
-    // create the two nodes
-    NodeContainer nodes;
-    nodes.Create(2);
-
-    // create the mobility models
-    Ptr<MobilityModel> a = CreateObject<ConstantPositionMobilityModel>();
-    Ptr<MobilityModel> b = CreateObject<ConstantPositionMobilityModel>();
-
-    // aggregate the nodes and the mobility models
-    nodes.Get(0)->AggregateObject(a);
-    nodes.Get(1)->AggregateObject(b);
-
-    Ptr<MobilityBuildingInfo> buildingInfoA = CreateObject<MobilityBuildingInfo>();
-    Ptr<MobilityBuildingInfo> buildingInfoB = CreateObject<MobilityBuildingInfo>();
-    a->AggregateObject(buildingInfoA); // operation usually done by BuildingsHelper::Install
-    buildingInfoA->MakeConsistent(a);
-
-    b->AggregateObject(buildingInfoB); // operation usually done by BuildingsHelper::Install
-    buildingInfoB->MakeConsistent(b);
-
-    Ptr<ChannelConditionModel> condModel = CreateObject<BuildingsChannelConditionModel>();
-
-    for (std::size_t i = 0; i < m_testVectors.GetN(); i++)
+    // clang-format off
+    m_testVectors = {
+        // PosA, PosB, B velocity, frequency, propagation model, O2I loss type, channel condition, mean and standard deviation of expected gaussian
+        // 6GHz, pedestrian, Low O2I loss
+        {{0, 0, 35.0}, {  10, 0, 1.5},  0, 6e9, RMa,  O2ILH::LOW,  -93.0, 4.5}, // RMa O2I
+        {{0, 0, 35.0}, { 100, 0, 1.5},  0, 6e9, RMa,  O2ILH::LOW, -112.0, 4.5}, // RMa O2I
+        {{0, 0, 10.0}, { 50, 15, 1.5},  0, 6e9, RMa,  O2ILH::LOW,  -97.0, 0.1}, // RMa O2O unblocked
+        {{0, 0, 10.0}, {1000, 0, 1.5},  0, 6e9, RMa,  O2ILH::LOW, -110.0, 0.1}, // RMa O2O blocked
+        {{0, 0, 25.0}, {  10, 0, 1.5},  0, 6e9, UMa,  O2ILH::LOW, -101.0, 5.3}, // UMa O2I
+        {{0, 0, 25.0}, { 100, 0, 1.5},  0, 6e9, UMa,  O2ILH::LOW, -125.0, 5.3}, // UMa O2I
+        {{0, 0, 10.0}, { 50, 15, 1.5},  0, 6e9, UMa,  O2ILH::LOW,  -96.0, 0.1}, // UMa O2O unblocked
+        {{0, 0, 10.0}, {1000, 0, 1.5},  0, 6e9, UMa,  O2ILH::LOW, -117.0, 0.1}, // UMa O2O blocked
+        {{0, 0, 10.0}, {  10, 0, 1.5},  0, 6e9, UMi,  O2ILH::LOW,  -96.0, 5.3}, // UMi O2I
+        {{0, 0, 10.0}, { 100, 0, 1.5},  0, 6e9, UMi,  O2ILH::LOW, -127.0, 5.0}, // UMi O2I
+        {{0, 0, 10.0}, { 50, 15, 1.5},  0, 6e9, UMi,  O2ILH::LOW,  -99.0, 0.1}, // UMi O2O unblocked
+        {{0, 0, 10.0}, {1000, 0, 1.5},  0, 6e9, UMi,  O2ILH::LOW, -119.0, 0.1}, // UMi O2O blocked
+        // 6GHz, pedestrian, High O2I loss
+        {{0, 0, 35.0}, {  10, 0, 1.5},  0, 6e9, RMa, O2ILH::HIGH,  -93.0, 4.5}, // RMa O2I
+        {{0, 0, 35.0}, { 100, 0, 1.5},  0, 6e9, RMa, O2ILH::HIGH, -112.0, 4.5}, // RMa O2I
+        {{0, 0, 10.0}, { 50, 15, 1.5},  0, 6e9, RMa, O2ILH::HIGH,  -97.0, 0.1}, // RMa O2O unblocked
+        {{0, 0, 10.0}, {1000, 0, 1.5},  0, 6e9, RMa, O2ILH::HIGH, -110.0, 0.1}, // RMa O2O blocked
+        {{0, 0, 25.0}, {  10, 0, 1.5},  0, 6e9, UMa, O2ILH::HIGH, -101.0, 5.3}, // UMa O2I
+        {{0, 0, 25.0}, { 100, 0, 1.5},  0, 6e9, UMa, O2ILH::HIGH, -125.0, 5.3}, // UMa O2I
+        {{0, 0, 10.0}, { 50, 15, 1.5},  0, 6e9, UMa, O2ILH::HIGH,  -96.0, 0.1}, // UMa O2O unblocked
+        {{0, 0, 10.0}, {1000, 0, 1.5},  0, 6e9, UMa, O2ILH::HIGH, -117.0, 0.1}, // UMa O2O blocked
+        {{0, 0, 10.0}, {  10, 0, 1.5},  0, 6e9, UMi, O2ILH::HIGH,  -95.0, 5.3}, // UMi O2I
+        {{0, 0, 10.0}, { 100, 0, 1.5},  0, 6e9, UMi, O2ILH::HIGH, -127.0, 5.3}, // UMi O2I
+        {{0, 0, 10.0}, { 50, 15, 1.5},  0, 6e9, UMi, O2ILH::HIGH,  -99.0, 0.1}, // UMi O2O unblocked
+        {{0, 0, 10.0}, {1000, 0, 1.5},  0, 6e9, UMi, O2ILH::HIGH, -119.0, 0.1}, // UMi O2O blocked
+        // 6GHz, vehicles, High O2I loss
+        {{0, 0, 35.0}, {  10, 0, 1.5}, 30, 6e9, RMa, O2ILH::HIGH,  -94.0, 4.5}, // RMa O2I
+        {{0, 0, 35.0}, { 100, 0, 1.5}, 30, 6e9, RMa, O2ILH::HIGH, -112.0, 4.5}, // RMa O2I
+        {{0, 0, 10.0}, { 50, 15, 1.5}, 30, 6e9, RMa, O2ILH::HIGH,  -98.0, 5.3}, // RMa O2O unblocked
+        {{0, 0, 10.0}, {1000, 0, 1.5}, 30, 6e9, RMa, O2ILH::HIGH, -110.0, 5.3}, // RMa O2O blocked
+        {{0, 0, 25.0}, {  10, 0, 1.5}, 30, 6e9, UMa, O2ILH::HIGH, -101.0, 5.3}, // UMa O2I
+        {{0, 0, 25.0}, { 100, 0, 1.5}, 30, 6e9, UMa, O2ILH::HIGH, -125.0, 5.3}, // UMa O2I
+        {{0, 0, 10.0}, { 50, 15, 1.5}, 30, 6e9, UMa, O2ILH::HIGH,  -96.0, 5.3}, // UMa O2O unblocked
+        {{0, 0, 10.0}, {1000, 0, 1.5}, 30, 6e9, UMa, O2ILH::HIGH, -117.0, 5.3}, // UMa O2O blocked
+        {{0, 0, 10.0}, {  10, 0, 1.5}, 30, 6e9, UMi, O2ILH::HIGH,  -95.0, 5.3}, // UMi O2I
+        {{0, 0, 10.0}, { 100, 0, 1.5}, 30, 6e9, UMi, O2ILH::HIGH, -127.0, 5.3}, // UMi O2I
+        {{0, 0, 10.0}, { 50, 15, 1.5}, 30, 6e9, UMi, O2ILH::HIGH, -100.0, 5.3}, // UMi O2O unblocked
+        {{0, 0, 10.0}, {1000, 0, 1.5}, 30, 6e9, UMi, O2ILH::HIGH, -119.0, 5.3}, // UMi O2O blocked
+        // Sub-6GHz, pedestrian, legacy O2I
+        {{0, 0, 35.0}, {  10, 0, 1.5},  0, 5e9, RMa, O2ILH::HIGH,  -97.0, 0.1}, // RMa O2I
+        {{0, 0, 35.0}, { 100, 0, 1.5},  0, 5e9, RMa, O2ILH::HIGH, -115.0, 0.1}, // RMa O2I
+        {{0, 0, 10.0}, { 50, 15, 1.5},  0, 5e9, RMa, O2ILH::HIGH,  -96.0, 0.1}, // RMa O2O unblocked
+        {{0, 0, 10.0}, {1000, 0, 1.5},  0, 5e9, RMa, O2ILH::HIGH, -108.0, 0.1}, // RMa O2O blocked
+        {{0, 0, 25.0}, {  10, 0, 1.5},  0, 5e9, UMa, O2ILH::HIGH, -108.0, 3.6}, // UMa O2I
+        {{0, 0, 25.0}, { 100, 0, 1.5},  0, 5e9, UMa, O2ILH::HIGH, -132.0, 3.6}, // UMa O2I
+        {{0, 0, 10.0}, { 50, 15, 1.5},  0, 5e9, UMa, O2ILH::HIGH,  -94.0, 0.1}, // UMa O2O unblocked
+        {{0, 0, 10.0}, {1000, 0, 1.5},  0, 5e9, UMa, O2ILH::HIGH, -117.0, 0.1}, // UMa O2O blocked
+        {{0, 0, 10.0}, {  10, 0, 1.5},  0, 5e9, UMi, O2ILH::HIGH, -103.0, 3.6}, // UMi O2I
+        {{0, 0, 10.0}, { 100, 0, 1.5},  0, 5e9, UMi, O2ILH::HIGH, -134.0, 3.6}, // UMi O2I
+        {{0, 0, 10.0}, { 50, 15, 1.5},  0, 5e9, UMi, O2ILH::HIGH,  -98.0, 0.1}, // UMi O2O unblocked
+        {{0, 0, 10.0}, {1000, 0, 1.5},  0, 5e9, UMi, O2ILH::HIGH, -119.0, 0.1}, // UMi O2O blocked
+        // Sub-6GHz, vehicles, legacy O2I
+        {{0, 0, 35.0}, {  10, 0, 1.5}, 30, 5e9, RMa, O2ILH::HIGH,  -97.0, 0.1}, // RMa O2I
+        {{0, 0, 35.0}, { 100, 0, 1.5}, 30, 5e9, RMa, O2ILH::HIGH, -115.0, 0.1}, // RMa O2I
+        {{0, 0, 10.0}, { 50, 15, 1.5}, 30, 5e9, RMa, O2ILH::HIGH,  -96.0, 5.0}, // RMa O2O unblocked
+        {{0, 0, 10.0}, {1000, 0, 1.5}, 30, 5e9, RMa, O2ILH::HIGH, -108.0, 5.0}, // RMa O2O blocked
+        {{0, 0, 25.0}, {  10, 0, 1.5}, 30, 5e9, UMa, O2ILH::HIGH, -108.0, 3.6}, // UMa O2I
+        {{0, 0, 25.0}, { 100, 0, 1.5}, 30, 5e9, UMa, O2ILH::HIGH, -132.0, 3.6}, // UMa O2I
+        {{0, 0, 10.0}, { 50, 15, 1.5}, 30, 5e9, UMa, O2ILH::HIGH, -103.0, 5.0}, // UMa O2O unblocked
+        {{0, 0, 10.0}, {1000, 0, 1.5}, 30, 5e9, UMa, O2ILH::HIGH, -117.0, 5.0}, // UMa O2O blocked
+        {{0, 0, 10.0}, {  10, 0, 1.5}, 30, 5e9, UMi, O2ILH::HIGH, -102.0, 3.6}, // UMi O2I
+        {{0, 0, 10.0}, { 100, 0, 1.5}, 30, 5e9, UMi, O2ILH::HIGH, -134.0, 3.6}, // UMi O2I
+        {{0, 0, 10.0}, { 50, 15, 1.5}, 30, 5e9, UMi, O2ILH::HIGH,  -98.0, 5.0}, // UMi O2O unblocked
+        {{0, 0, 10.0}, {1000, 0, 1.5}, 30, 5e9, UMi, O2ILH::HIGH, -119.0, 5.0}, // UMi O2O blocked
+    };
+    // clang-format on
+    RngSeedManager::SetSeed(1);
+    RngSeedManager::SetRun(1);
+    for (std::size_t i = 0; i < m_testVectors.size(); i++)
     {
-        TestVector testVector = m_testVectors.Get(i);
+        RngSeedManager::ResetNextStreamIndex();
+        // create the factory for the propagation loss model
+        ObjectFactory propModelFactory;
+
+        auto building = CreateObject<Building>();
+        building->SetExtWallsType(Building::ExtWallsType_t::ConcreteWithWindows);
+        building->SetNRoomsX(1);
+        building->SetNRoomsY(1);
+        building->SetNFloors(2);
+        building->SetBoundaries(Box(0.0, 100.0, 0.0, 10.0, 0.0, 5.0));
+
+        // create the two nodes
+        NodeContainer nodes;
+        nodes.Create(2);
+
+        // create the mobility models
+        Ptr<MobilityModel> a = CreateObject<ConstantPositionMobilityModel>();
+        Ptr<MobilityModel> b = CreateObject<ConstantVelocityMobilityModel>();
+        Ptr<ConstantVelocityMobilityModel> bcv = DynamicCast<ConstantVelocityMobilityModel>(b);
+
+        // aggregate the nodes and the mobility models
+        nodes.Get(0)->AggregateObject(a);
+        nodes.Get(1)->AggregateObject(b);
+
+        Ptr<MobilityBuildingInfo> buildingInfoA = CreateObject<MobilityBuildingInfo>();
+        Ptr<MobilityBuildingInfo> buildingInfoB = CreateObject<MobilityBuildingInfo>();
+        a->AggregateObject(buildingInfoA); // operation usually done by BuildingsHelper::Install
+        buildingInfoA->MakeConsistent(a);
+
+        b->AggregateObject(buildingInfoB); // operation usually done by BuildingsHelper::Install
+        buildingInfoB->MakeConsistent(b);
+
+        Ptr<ChannelConditionModel> condModel = CreateObject<BuildingsChannelConditionModel>();
+        int64_t streamOffset = 0;
+        streamOffset += condModel->AssignStreams(streamOffset);
+
+        // Configure test case setup
+        const auto& testVector = m_testVectors.at(i);
         a->SetPosition(testVector.m_positionA);
         b->SetPosition(testVector.m_positionB);
-
-        Ptr<ChannelCondition> cond = condModel->GetChannelCondition(a, b);
-
-        propModelFactory.SetTypeId(testVector.m_propModel);
-        m_propModel = propModelFactory.Create<ThreeGppPropagationLossModel>();
-        m_propModel->SetAttribute("Frequency", DoubleValue(testVector.m_frequency));
-        m_propModel->SetAttribute("ShadowingEnabled", BooleanValue(false));
-        m_propModel->SetChannelConditionModel(condModel);
-
+        bcv->SetVelocity({testVector.m_ueVelocity / 3.6, 0, 0});
         bool isAIndoor = buildingInfoA->IsIndoor();
         bool isBIndoor = buildingInfoB->IsIndoor();
 
+        Ptr<ChannelCondition> cond = condModel->GetChannelCondition(a, b);
+        cond->SetO2iLowHighCondition(testVector.m_o2iLossType);
         if (!isAIndoor && !isBIndoor) // a and b are outdoor
         {
-            cond->SetLosCondition(ChannelCondition::LosConditionValue::LOS);
             cond->SetO2iCondition(ChannelCondition::O2iConditionValue::O2O);
-
-            // check rcv power to be equal to the calculated value without losses
-            NS_TEST_EXPECT_MSG_EQ_TOL(m_propModel->CalcRxPower(testVector.m_pt, a, b),
-                                      testVector.m_pr,
-                                      m_tolerance,
-                                      "rcv power is not equal expected value");
         }
         else
         {
-            cond->SetLosCondition(ChannelCondition::LosConditionValue::LOS);
             cond->SetO2iCondition(ChannelCondition::O2iConditionValue::O2I);
-            cond->SetO2iLowHighCondition(ChannelCondition::O2iLowHighConditionValue::LOW);
+        }
 
-            // check rcv power to be lower than the calculated without losses
-            NS_TEST_EXPECT_MSG_LT(m_propModel->CalcRxPower(testVector.m_pt, a, b),
-                                  testVector.m_pr,
-                                  "rcv power is not less than calculated value");
+        propModelFactory.SetTypeId(testVector.m_propModel);
+        m_propModel = propModelFactory.Create<ThreeGppPropagationLossModel>();
+        m_propModel->SetAttribute("Frequency", DoubleValue(testVector.m_frequency));
+        m_propModel->SetAttribute("ShadowingEnabled", BooleanValue(false));
+        streamOffset += m_propModel->AssignStreams(streamOffset);
+        streamOffset += m_propModel->GetChannelConditionModel()->AssignStreams(streamOffset);
+        m_propModel->SetChannelConditionModel(condModel);
+        streamOffset += m_propModel->AssignStreams(streamOffset);
+        m_propModel->GetChannelConditionModel()->AssignStreams(streamOffset);
+        std::vector<double> samples(1000);
+        for (auto& sample : samples)
+        {
+            // Compute total loss
+            sample = m_propModel->CalcRxPower(0.0, a, b);
+            // Trigger another random variable usage
+            m_propModel->ClearO2iLossCacheMap();
         }
+
+        auto getMeanAndStddev = [](const std::vector<double> vec) {
+            // Calculate the mean
+            double sum = std::accumulate(vec.begin(), vec.end(), 0.0);
+            double mean = sum / vec.size();
+
+            // Calculate variance and standard deviation
+            double sq_sum = std::inner_product(vec.begin(), vec.end(), vec.begin(), 0.0);
+            double stddev = std::sqrt((sq_sum / vec.size()) - mean * mean);
+            return std::make_pair(mean, stddev);
+        };
+
+        auto [mean, stddev] = getMeanAndStddev(samples);
+        NS_TEST_ASSERT_MSG_EQ_TOL(mean,
+                                  testVector.m_expectedMean,
+                                  -testVector.m_expectedMean * 0.1,
+                                  "Test vector " << i << ", mean outside expected range");
+        NS_TEST_ASSERT_MSG_EQ_TOL(stddev,
+                                  testVector.m_expectedStddev,
+                                  std::max(0.1, testVector.m_expectedStddev * 0.1),
+                                  "Test vector " << i
+                                                 << ", standard deviation outside expected range");
         m_propModel = nullptr;
+        Simulator::Destroy();
     }
-    Simulator::Destroy();
 }
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/click/CMakeLists.txt ns-3.47/src/click/CMakeLists.txt
--- ns-3.46/src/click/CMakeLists.txt	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/click/CMakeLists.txt	2026-02-16 16:08:49.576229800 -0800
@@ -41,7 +41,10 @@
   )
 endif()
 
-include_directories(${click_INCLUDE_DIRS})
+include_directories(
+  SYSTEM
+  ${click_INCLUDE_DIRS}
+)
 set(NS3_CLICK
     "ON"
     CACHE INTERNAL
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/config-store/model/display-functions.cc ns-3.47/src/config-store/model/display-functions.cc
--- ns-3.46/src/config-store/model/display-functions.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/config-store/model/display-functions.cc	2026-02-16 16:08:49.578230000 -0800
@@ -7,6 +7,8 @@
 
 #include "display-functions.h"
 
+#include "model-node-creator.h"
+#include "model-typeid-creator.h"
 #include "raw-text-config.h"
 
 #include "ns3/config.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/config-store/model/display-functions.h ns-3.47/src/config-store/model/display-functions.h
--- ns-3.46/src/config-store/model/display-functions.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/config-store/model/display-functions.h	2026-02-16 16:08:49.578230000 -0800
@@ -7,9 +7,6 @@
 #ifndef DISPLAY_FUNCTIONS_H
 #define DISPLAY_FUNCTIONS_H
 
-#include "model-node-creator.h"
-#include "model-typeid-creator.h"
-
 #include <gtk/gtk.h>
 
 namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/config-store/model/gtk-config-store.cc ns-3.47/src/config-store/model/gtk-config-store.cc
--- ns-3.46/src/config-store/model/gtk-config-store.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/config-store/model/gtk-config-store.cc	2026-02-16 16:08:49.578230000 -0800
@@ -8,7 +8,8 @@
 #include "gtk-config-store.h"
 
 #include "display-functions.h"
-#include "raw-text-config.h"
+#include "model-node-creator.h"
+#include "model-typeid-creator.h"
 
 #include "ns3/log.h"
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/config-store/model/model-node-creator.h ns-3.47/src/config-store/model/model-node-creator.h
--- ns-3.46/src/config-store/model/model-node-creator.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/config-store/model/model-node-creator.h	2026-02-16 16:08:49.578230000 -0800
@@ -5,6 +5,9 @@
  *          Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
 
+#ifndef MODEL_NODE_CREATOR_H
+#define MODEL_NODE_CREATOR_H
+
 #include "attribute-iterator.h"
 
 #include <gtk/gtk.h>
@@ -90,3 +93,5 @@
     std::vector<GtkTreeIter*> m_iters; ///< attribute tree item
 };
 } // namespace ns3
+
+#endif // MODEL_NODE_CREATOR_H
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/config-store/model/model-typeid-creator.h ns-3.47/src/config-store/model/model-typeid-creator.h
--- ns-3.46/src/config-store/model/model-typeid-creator.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/config-store/model/model-typeid-creator.h	2026-02-16 16:08:49.578230000 -0800
@@ -4,6 +4,9 @@
  * Author: Moatamri Faker <faker.moatamri@sophia.inria.fr>
  */
 
+#ifndef MODEL_TYPEID_CREATOR_H
+#define MODEL_TYPEID_CREATOR_H
+
 #include "attribute-default-iterator.h"
 
 #include "ns3/type-id.h"
@@ -99,3 +102,5 @@
     std::vector<GtkTreeIter*> m_iters;
 };
 } // namespace ns3
+
+#endif // MODEL_TYPEID_CREATOR_H
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/core/examples/assert-example.cc ns-3.47/src/core/examples/assert-example.cc
--- ns-3.46/src/core/examples/assert-example.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/core/examples/assert-example.cc	2026-02-16 16:08:49.579229800 -0800
@@ -24,7 +24,7 @@
 int
 main(int argc, char** argv)
 {
-    CommandLine cmd;
+    CommandLine cmd(__FILE__);
     cmd.Parse(argc, argv);
 
     std::cout << "NS_ASSERT_MSG example\n"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/core/examples/empirical-random-variable-example.cc ns-3.47/src/core/examples/empirical-random-variable-example.cc
--- ns-3.46/src/core/examples/empirical-random-variable-example.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/core/examples/empirical-random-variable-example.cc	2026-02-16 16:08:49.579229800 -0800
@@ -177,7 +177,7 @@
     long n = 1000000;
     bool disableAnti = false;
     bool single = false;
-    CommandLine cmd;
+    CommandLine cmd(__FILE__);
     cmd.AddValue("count", "how many draws to make from the rng", n);
     cmd.AddValue("antithetic", "disable antithetic sampling", disableAnti);
     cmd.AddValue("single", "sample a single time", single);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/core/examples/hash-example.cc ns-3.47/src/core/examples/hash-example.cc
--- ns-3.46/src/core/examples/hash-example.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/core/examples/hash-example.cc	2026-02-16 16:08:49.579229800 -0800
@@ -6,7 +6,6 @@
 #include "ns3/hash.h"
 
 #include <algorithm> // find
-#include <climits>   // CHAR_BIT
 #include <fstream>
 #include <iomanip>
 #include <iostream>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/core/examples/log-example.cc ns-3.47/src/core/examples/log-example.cc
--- ns-3.46/src/core/examples/log-example.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/core/examples/log-example.cc	2026-02-16 16:08:49.579229800 -0800
@@ -96,7 +96,7 @@
 int
 main(int argc, char** argv)
 {
-    CommandLine cmd;
+    CommandLine cmd(__FILE__);
     cmd.Parse(argc, argv);
 
     NS_LOG_DEBUG("Creating a Node");
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/core/examples/sample-show-progress.cc ns-3.47/src/core/examples/sample-show-progress.cc
--- ns-3.46/src/core/examples/sample-show-progress.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/core/examples/sample-show-progress.cc	2026-02-16 16:08:49.579229800 -0800
@@ -22,7 +22,6 @@
 #include "ns3/core-module.h"
 
 #include <chrono>
-#include <iomanip>
 #include <string>
 #include <thread>
 
@@ -39,7 +38,7 @@
  *
  * Inspired by PHOLD.
  */
-class Hold : public SimpleRefCount<Hold>
+class Hold
 {
   public:
     /**
@@ -120,7 +119,7 @@
               << "average event sleep time:  " << wait.As(Time::MS) << "\n"
               << "total simulation run time: " << stop.As(Time::S) << std::endl;
 
-    Ptr<Hold> h = Create<Hold>(wait, interval);
+    auto h = std::make_unique<Hold>(wait, interval);
     h->Event();
 
     Simulator::Stop(stop);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/core/examples/sample-simulator.py ns-3.47/src/core/examples/sample-simulator.py
--- ns-3.46/src/core/examples/sample-simulator.py	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/core/examples/sample-simulator.py	2026-02-16 16:08:49.579229800 -0800
@@ -36,8 +36,7 @@
     print("I should never be called... ")
 
 
-ns.cppyy.cppdef(
-    """
+ns.cppyy.cppdef("""
     #include "CPyCppyy/API.h"
 
     using namespace ns3;
@@ -99,8 +98,7 @@
     {
         return MakeEvent(&CancelledFunctionCpp);
     }
-   """
-)
+   """)
 
 
 def main(argv):
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/core/examples/system-path-examples.cc ns-3.47/src/core/examples/system-path-examples.cc
--- ns-3.46/src/core/examples/system-path-examples.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/core/examples/system-path-examples.cc	2026-02-16 16:08:49.579229800 -0800
@@ -6,9 +6,9 @@
  * Author: Peter D. Barnes, Jr. <pdbarnes@llnl.gov>
  */
 
-#include "ns3/core-module.h"
+#include "ns3/command-line.h"
+#include "ns3/system-path.h"
 
-#include <iomanip>
 #include <iostream>
 #include <string>
 
@@ -25,26 +25,30 @@
 int
 main(int argc, char* argv[])
 {
-    std::string path = "/usr/share/dict/";
+    std::string path = FindSelfDirectory();
 
-    CommandLine cmd;
+    CommandLine cmd(__FILE__);
     cmd.Usage("SystemPath examples.\n");
 
     cmd.AddValue("path", "Path to demonstrate SystemPath functions.", path);
     cmd.Parse(argc, argv);
 
-    // Show initial values:
-    std::cout << std::endl;
-    std::cout << cmd.GetName() << ":" << std::endl;
-
-    std::cout << "FindSelfDirectory:   " << FindSelfDirectory() << std::endl;
-
-    std::cout << "Demonstration path:  " << path << std::endl;
-    std::cout << "Exists?              " << (Exists(path) ? "yes" : "no") << std::endl;
-
-    auto foo = Append(path, "foo");
-    std::cout << "Append 'foo':        " << foo << std::endl;
-    std::cout << "Exists?              " << (Exists(foo) ? "yes" : "no") << std::endl;
+    // Print system path information
+    std::cout << "Example name             : " << cmd.GetName() << "\n";
+    std::cout << "FindSelf                 : " << FindSelf() << "\n";
+    std::cout << "FindSelfDirectory        : " << FindSelfDirectory() << "\n";
+    std::cout << "Temporary directory name : " << MakeTemporaryDirectoryName() << "\n";
+    std::cout << "\n";
+
+    std::cout << "Path                     : " << path << "\n";
+    std::cout << "Exists                   : " << std::boolalpha << Exists(path) << "\n";
+    std::cout << "Valid system path        : " << CreateValidSystemPath(path) << "\n";
+    std::cout << "\n";
+
+    auto pathFoo = Append(path, "foo");
+    std::cout << "Append 'foo' to path     : " << pathFoo << "\n";
+    std::cout << "Exists                   : " << std::boolalpha << Exists(pathFoo) << "\n";
+    std::cout << "\n";
 
     std::cout << "Split path:\n";
     auto items = Split(path);
@@ -52,16 +56,17 @@
     {
         std::cout << "    '" << item << "'\n";
     }
-    std::cout << std::endl;
+    std::cout << "\n";
 
-    std::cout << "Successive Joins: \n";
+    std::cout << "Successive joins of the split path:\n";
     for (auto it = items.begin(); it != items.end(); ++it)
     {
         auto partial = Join(items.begin(), it);
         std::cout << "    '" << partial << "'\n";
     }
+    std::cout << "\n";
 
-    std::cout << "Files in the directory: \n";
+    std::cout << "Files in the path directory:\n";
     auto files = ReadFiles(path);
     for (const auto& item : files)
     {
